unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Dialogs, StdCtrls, Registry;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function GetRegStrings(RegPath: String): String;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Label1.Caption := 'SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\ODBC Drivers';
  Memo1.Text := GetRegStrings('SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\ODBC Drivers');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Label1.Caption := 'SOFTWARE\ODBC\ODBCINST.INI\ODBC Drivers';
  Memo1.Text := GetRegStrings('SOFTWARE\ODBC\ODBCINST.INI\ODBC Drivers');
end;

function TForm1.GetRegStrings(RegPath: String): String;
var
  Reg: TRegistry;
  RegStrings: TStrings;
begin
  try
    Reg := TRegistry.Create(KEY_READ);
    RegStrings := TStringList.Create;
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKeyReadOnly(RegPath) then
    begin
      Reg.GetValueNames(RegStrings);
      Result := RegStrings.Text;
    end;
  finally
    RegStrings.Free;
    Reg.Free;
  end;
end;

end.
